#!/usr/bin/python

import pickle, copy

if __name__ == "__main__":
    records = pickle.load(file("results.dat", "rb"))
    table1 = "num_regions"
    table1 = "cost"

    sizes = set()
    programs = set()
    arrangements = set()
    fixed_costs = set()
    new_records = dict()

    for record in records:
        p = record["program"]
        s = record["spm_size"]
        a = record["arrangement"]
        f = record["fixed_cost"]
        programs.add(p)
        sizes.add(s)
        arrangements.add(a)
        fixed_costs.add(f)
        record["cost"] = record.get("spm_cost", None)
        record["bytes"] = record.get("spm_bytes", None)
        new_records[(p, s, a, f)] = record

        if a == "ELA2":
            record = copy.copy(record)
            record["cost"] = record["cache_cost"]
            record["bytes"] = record["cache_bytes"]
            a = "C"
            arrangements.add(a)
            new_records[(p, s, a, f)] = record


    programs = list(programs)
    programs.sort()
    sizes = list(sizes)
    sizes.sort()
    arrangements = list(arrangements)
    arrangements.sort()
    fixed_costs = list(fixed_costs)
    fixed_costs.sort()
    print programs
    print sizes
    print fixed_costs

    print '%-15s %-5s  ' % ('', ''),
    for a in arrangements:
        print '%10s' % a,

    print ''

    f = 20
    for p in programs:
        for s in sizes:
            print '%-15s %-5u  ' % (p, s),
            for a in arrangements:
                r = new_records.get((p, s, a, f), None)
                out = "/"
                if r != None:
                    r = r.get(table1, None) 
                if r != None:
                    out = '%u' % (r)

                print '%10s' % out,

            print ''

    def sf(val):
        if val >= 99.95:
            return("$%1.0f$ " % val)
        if val >= 9.95:
            return("$%1.1f$ " % val)
        if val >= 0.995:
            return("$%1.2f$ " % val)

        return("$%1.2f$ " % val)

    def ctable(fname, top):
        fd = file(fname, "wt")
        fd.write("%% fname %s  top %s\n" % (fname, top))
        fd.write(r"\begin{tabular}{l")
        fd.write("r" * len(sizes))
        fd.write("}\n")
        fd.write(r"\hline")
        fd.write("\n")
        for s in sizes:
            fd.write("&$%u$" % s)
        fd.write(r"\\")
        fd.write("\n")
        fd.write(r"\hline")
        fd.write("\n")

        for p in programs:
            fd.write("%20s " % p[:-2])
            for s in sizes:
                r1 = new_records.get((p, s, top, 20), None)
                r2 = new_records.get((p, s, "ELA2", 20), None)
                out = "-"
                if (r1 != None) and (r2 != None):
                    r1 = r1.get("cost", None) 
                    r2 = r2.get("cost", None) 
                if (r1 != None) and (r2 != None):
                    out = sf(float(r1) / r2)

                fd.write("&%7s " % out)
                        
            fd.write(r"\\")
            fd.write("\n")
        fd.write(r"\hline")
        fd.write("\n")
        fd.write(r"\end{tabular}")
        fd.write("\n")
        fd.close()
        print file(fname, "rt").read()
                
    ctable("c1.tex", "2S")
    ctable("c2.tex", "ELA1")
    ctable("c3.tex", "C")

    fd = file("c4.tex", "wt")
    fd.write(r"\begin{tabular}{l")
    fd.write("r" * len(fixed_costs))
    fd.write("}\n")
    fd.write(r"\hline")
    fd.write("\n")
    fd.write(r"&\multicolumn{%u}{c}{$L(s) = $} \\" % len(fixed_costs))
    fd.write("\n")
    for f in fixed_costs:
        fd.write("&$s + %u$" % f)
    fd.write(r"\\")
    fd.write("\n")
    fd.write(r"\hline")
    fd.write("\n")
    s = 256
    for p in programs:
        fd.write("%20s " % p[:-2])
        for f in fixed_costs:
            r1 = new_records.get((p, s, "C", f), None)
            r2 = new_records.get((p, s, "ELA2", f), None)
            out = "-"
            if (r1 != None) and (r2 != None):
                r1 = r1.get("cost", None) 
                r2 = r2.get("cost", None) 
            if (r1 != None) and (r2 != None):
                out = sf(float(r1) / r2)

            fd.write("&%7s " % out)
                    
        fd.write(r"\\")
        fd.write("\n")
    fd.write(r"\hline")
    fd.write("\n")
    fd.write(r"\end{tabular}")
    fd.write("\n")
    fd.close()

def X():

    for table1 in ("bytes", "cost"):
        for table2 in ("rel", "spm", "cache"):
            out = file("%s-%s.tex" % (table1, table2), "wt")
            for p in programs:
                out.write("%-20s" % p)
                for s in sizes:
                    data = ""
                    record = new_records.get((p, s), None)
                    if record:
                        if table2 == "rel":
                            data = "%1.3f" % (
                                    float(record["cache_%s" % table1]) /
                                    float(record["spm_%s" % table1]))

                        elif table2 == "spm":
                            data = "%u" % (record["spm_%s" % table1])
                         
                        elif table2 == "cache":
                            data = "%u" % (record["cache_%s" % table1])
                        
                    out.write("& %-10s " % data)
                out.write(r"\\")
                out.write("\n")

            out.close()


